## com.google.javascript.rhino.jstype
Class EnumElementType

    java.lang.Object
      com.google.javascript.rhino.jstype.JSType
          com.google.javascript.rhino.jstype.ObjectType
              com.google.javascript.rhino.jstype.EnumElementType

All Implemented Interfaces:
  StaticScope<JSType>, Serializable

    public class EnumElementType

extends ObjectType

The type of individual elements of an enum type (see `EnumType`).

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.ObjectType
`ObjectType.Property`

Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.JSType
`JSType.TypePair`

Field Summary

Fields inherited from class com.google.javascript.rhino.jstype.JSType
`EMPTY_TYPE_COMPONENT, ENUMDECL, NOT_A_CLASS, NOT_A_TYPE, NOT_ENUMDECL, UNKNOWN_NAME`

Method Summary
`JSType` | `autoboxesTo()` Gets the type to which this type auto-boxes.
`boolean` | `canBeCalled()` This predicate is used to test whether a given type can be used as the 'function' in a function call.
`JSType` | `findPropertyType(String propertyName)` Coerces this type to an Object type, then gets the type of the property whose name is given.
`FunctionType` | `getConstructor()` Gets this object's constructor.
`ObjectType` | `getImplicitPrototype()` Gets the implicit prototype (a.k.a.
`JSType` | `getPrimitiveType()` Gets the primitive type of this enum element.
`int` | `getPropertiesCount()` Gets the number of properties of this object.
`JSType` | `getPropertyType(String propertyName)` Gets the property type of the property whose name is given.
`String` | `getReferenceName()` Gets the reference name for this object.
`ObjectType.Property` | `getSlot(String name)` Returns any defined slot within this scope for this name.
`int` | `hashCode()` If this is equal to a NamedType object, its hashCode must be equal to the hashCode of the NamedType object.
`boolean` | `hasProperty(String propertyName)` Checks whether the property whose name is given is present on the object.
`boolean` | `hasReferenceName()` Returns true if the object is named.
`boolean` | `isEquivalentTo(JSType that)` Checks if two types are equivalent.
`boolean` | `isNominalType()` Whether this type is a nominal type (a named instance object or a named enum).
`boolean` | `isNullable()` This predicate determines whether objects of this type can have the null value, and therefore can appear in contexts where null is expected.
`boolean` | `isObject()` Tests whether this type is an `Object`, or any subtype thereof.
`boolean` | `isPropertyTypeDeclared(String propertyName)` Checks whether the property's type is declared.
`boolean` | `isPropertyTypeInferred(String propertyName)` Checks whether the property's type is inferred.
`boolean` | `isSubtype(JSType that)` Checks whether `this` is a subtype of `that`.
`boolean` | `matchesNumberContext()` This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.
`boolean` | `matchesObjectContext()` This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement.
`boolean` | `matchesStringContext()` This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator.
`TernaryValue` | `testForEquality(JSType that)` Compares `this` and `that`.
`EnumElementType` | `toMaybeEnumElementType()` Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.

`

`<T> T`

`

`visit(Visitor<T> visitor)`
Visit this type with the given visitor.

Methods inherited from class com.google.javascript.rhino.jstype.ObjectType

`cast, clearCachedValues, createDelegateSuffix, defineDeclaredProperty, defineInferredProperty, getCtorExtendedInterfaces, getCtorImplementedInterfaces, getDisplayName, getIndexType, getJSDocInfo, getNormalizedReferenceName, getOwnerFunction, getOwnPropertyJSDocInfo, getOwnPropertyNames, getOwnSlot, getParameterType, getParentScope, getPossibleToBooleanOutcomes, getPropertyNames, getPropertyNode, getRootNode, getTypeOfThis, hasCachedValues, hasOwnProperty, isFunctionPrototypeType, isNativeObjectType, isPropertyInExterns, isUnknownType, removeProperty, setJSDocInfo, setPropertyJSDocInfo`

Methods inherited from class com.google.javascript.rhino.jstype.JSType

`autobox, canAssignTo, canTestForEqualityWith, canTestForShallowEqualityWith, clearResolved, collapseUnion, dereference, differsFrom, equals, forceResolve, getGreatestSubtype, getLeastSupertype, getRestrictedTypeGivenToBooleanOutcome, getTypesUnderEquality, getTypesUnderInequality, getTypesUnderShallowEquality, getTypesUnderShallowInequality, hasDisplayName, isAllType, isArrayType, isBooleanObjectType, isBooleanValueType, isCheckedUnknownType, isConstructor, isDateType, isEmptyType, isEnumElementType, isEnumType, isEquivalent, isFunctionType, isGlobalThisType, isInstanceType, isInterface, isNominalConstructor, isNoObjectType, isNoResolvedType, isNoType, isNullType, isNumber, isNumberObjectType, isNumberValueType, isOrdinaryFunction, isRecordType, isRegexpType, isResolved, isString, isStringObjectType, isStringValueType, isTemplateType, isUnionType, isVoidType, matchConstraint, matchesInt32Context, matchesUint32Context, resolve, restrictByNotNullOrUndefined, setValidator, toAnnotationString, toDebugHashCodeString, toMaybeEnumType, toMaybeFunctionType, toMaybeFunctionType, toMaybeUnionType, toObjectType, toString, unboxesTo`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getSlot

    public ObjectType.Property getSlot(String name)

  Description copied from interface: `StaticScope`
  Returns any defined slot within this scope for this name. This call continues searching through parent scopes if a slot with this name is not found in the current scope.

  Specified by:
    `getSlot` in interface `StaticScope<JSType>`
  Specified by:
    `getSlot` in class `ObjectType`
  Parameters:
    `name` - The name of the variable slot to look up.
  Returns:
    The defined slot for the variable, or `null` if no definition exists.

### toMaybeEnumElementType

    public EnumElementType toMaybeEnumElementType()

  Description copied from class: `JSType`
  Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.

  Overrides:
    `toMaybeEnumElementType` in class `JSType`

### matchesNumberContext

    public boolean matchesNumberContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.

  Overrides:
    `matchesNumberContext` in class `JSType`

### matchesStringContext

    public boolean matchesStringContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator. All types have at least the potential for converting to `String`. When we add externally defined types, such as a browser OM, we may choose to add types that do not automatically convert to `String`.

  Overrides:
    `matchesStringContext` in class `JSType`

### matchesObjectContext

    public boolean matchesObjectContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement. Most types we will encounter, except notably `null`, have at least the potential for converting to `Object`. Host defined objects can get peculiar.

  Overrides:
    `matchesObjectContext` in class `JSType`

### canBeCalled

    public boolean canBeCalled()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can be used as the 'function' in a function call.

  Overrides:
    `canBeCalled` in class `JSType`
  Returns:
    `true` if this type might be callable.

### isObject

    public boolean isObject()

  Description copied from class: `JSType`
  Tests whether this type is an `Object`, or any subtype thereof.

  Overrides:
    `isObject` in class `ObjectType`
  Returns:
    `this &lt;: Object`

### testForEquality

    public TernaryValue testForEquality(JSType that)

  Description copied from class: `JSType`
  Compares `this` and `that`.

  Overrides:
    `testForEquality` in class `ObjectType`
  Returns:
    - `TernaryValue.TRUE` if the comparison of values of `this` type and `that` always succeed (such as `undefined` compared to `null`)
    - `TernaryValue.FALSE` if the comparison of values of `this` type and `that` always fails (such as `undefined` compared to `number`)
    - `TernaryValue.UNKNOWN` if the comparison can succeed or fail depending on the concrete values

### isNullable

    public boolean isNullable()

  This predicate determines whether objects of this type can have the null value, and therefore can appear in contexts where null is expected.

  Overrides:
    `isNullable` in class `JSType`
  Returns:
    true for everything but Number and Boolean types.

### isNominalType

    public boolean isNominalType()

  Description copied from class: `JSType`
  Whether this type is a nominal type (a named instance object or a named enum).

  Overrides:
    `isNominalType` in class `JSType`

### isEquivalentTo

    public boolean isEquivalentTo(JSType that)

  Description copied from class: `JSType`
  Checks if two types are equivalent.

  Overrides:
    `isEquivalentTo` in class `JSType`

### hashCode

    public int hashCode()

  If this is equal to a NamedType object, its hashCode must be equal to the hashCode of the NamedType object.

  Overrides:
    `hashCode` in class `JSType`

### getReferenceName

    public String getReferenceName()

  Description copied from class: `ObjectType`
  Gets the reference name for this object. This includes named types like constructors, prototypes, and enums. It notably does not include literal types like strings and booleans and structural types.

  Specified by:
    `getReferenceName` in class `ObjectType`
  Returns:
    the object's name or `null` if this is an anonymous object

### hasReferenceName

    public boolean hasReferenceName()

  Description copied from class: `ObjectType`
  Returns true if the object is named.

  Overrides:
    `hasReferenceName` in class `ObjectType`
  Returns:
    true if the object is named, false if it is anonymous

### isSubtype

    public boolean isSubtype(JSType that)

  Description copied from class: `JSType`
  Checks whether `this` is a subtype of `that`.

  Subtyping rules:

  - (unknown) — every type is a subtype of the Unknown type.
  - (no) — the No type is a subtype of every type.
  - (no-object) — the NoObject type is a subtype of every object type (i.e. subtypes of the Object type).
  - (ref) — a type is a subtype of itself.
  - (union-l) — A union type is a subtype of a type U if all the union type's constituents are a subtype of U. Formally
    `(T<sub>1</sub>, &hellip;, T<sub>n</sub>) &lt;: U` if and only `T<sub>k</sub> &lt;: U` for all `k &isin; 1..n`.
  - (union-r) — A type U is a subtype of a union type if it is a subtype of one of the union type's constituents. Formally
    `U &lt;: (T<sub>1</sub>, &hellip;, T<sub>n</sub>)` if and only if `U &lt;: T<sub>k</sub>` for some index `k`.
  - (objects) — an Object `O<sub>1</sub>` is a subtype of an object `O<sub>2</sub>` if it has more properties than `O<sub>2</sub>` and all common properties are pairwise subtypes.

  Overrides:
    `isSubtype` in class `JSType`
  Returns:
    `this &lt;: that`

### visit

    public <T> T visit(Visitor<T> visitor)

  Description copied from class: `JSType`
  Visit this type with the given visitor.

  Overrides:
    `visit` in class `ObjectType`
  Returns:
    the value returned by the visitor
  See Also:
    `Visitor`

### isPropertyTypeDeclared

    public boolean isPropertyTypeDeclared(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property's type is declared.

  Specified by:
    `isPropertyTypeDeclared` in class `ObjectType`

### isPropertyTypeInferred

    public boolean isPropertyTypeInferred(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property's type is inferred.

  Specified by:
    `isPropertyTypeInferred` in class `ObjectType`

### getImplicitPrototype

    public ObjectType getImplicitPrototype()

  Description copied from class: `ObjectType`
  Gets the implicit prototype (a.k.a. the `[[Prototype]]` property).

  Specified by:
    `getImplicitPrototype` in class `ObjectType`

### getPropertiesCount

    public int getPropertiesCount()

  Description copied from class: `ObjectType`
  Gets the number of properties of this object.

  Specified by:
    `getPropertiesCount` in class `ObjectType`

### findPropertyType

    public JSType findPropertyType(String propertyName)

  Description copied from class: `JSType`
  Coerces this type to an Object type, then gets the type of the property whose name is given. Unlike `ObjectType.getPropertyType(java.lang.String)`, returns null if the property is not found.

  Overrides:
    `findPropertyType` in class `ObjectType`
  Returns:
    The property's type. `null` if the current type cannot have properties, or if the type is not found.

### getPropertyType

    public JSType getPropertyType(String propertyName)

  Description copied from class: `ObjectType`
  Gets the property type of the property whose name is given. If the underlying object does not have this property, the Unknown type is returned to indicate that no information is available on this property.

  Specified by:
    `getPropertyType` in class `ObjectType`
  Returns:
    the property's type or `UnknownType`. This method never returns `null`.

### hasProperty

    public boolean hasProperty(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property whose name is given is present on the object.

  Specified by:
    `hasProperty` in class `ObjectType`

### getConstructor

    public FunctionType getConstructor()

  Description copied from class: `ObjectType`
  Gets this object's constructor.

  Specified by:
    `getConstructor` in class `ObjectType`
  Returns:
    this object's constructor or `null` if it is a native object (constructed natively v.s. by instantiation of a function)

### autoboxesTo

    public JSType autoboxesTo()

  Description copied from class: `JSType`
  Gets the type to which this type auto-boxes.

  Overrides:
    `autoboxesTo` in class `JSType`
  Returns:
    the auto-boxed type or `null` if this type does not auto-box

### getPrimitiveType

    public JSType getPrimitiveType()

  Gets the primitive type of this enum element.